/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/08/2017
 --------------------------------------------------------
*/
package com.portofolio.entity;

import org.hibernate.annotations.ForeignKey;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.portofolio.entity.vo.JenisProfileId;

import org.hibernate.annotations.Type;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import com.fasterxml.jackson.annotation.JsonIgnore;

import static com.portofolio.base.adapter.DatabaseAdapter.Constant.*;

import javax.persistence.*;
import javax.validation.constraints.NotNull;


@Entity
@Table(name = "JenisProfile_M",indexes = {@Index(name = "JenisProfile_M_Index",  columnList="statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class JenisProfile {

	private static final String cDefKdJenisProfile = INTEGER;
	@Column(name = "KdJenisProfile", columnDefinition = cDefKdJenisProfile)
    @Id
    @GeneratedValue
	private Integer kdJenisProfile;

	private static final String cDefKdJenisProfileHead = INTEGER;
	@Column(name = "KdJenisProfileHead", columnDefinition = cDefKdJenisProfileHead)
	private Integer kdJenisProfileHead;

	private static final String cDefJenisProfile = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "JenisProfile", columnDefinition = cDefJenisProfile)
	@NotNull(message = "jenisprofile.jenisprofile.notnull")
	private String namaJenisProfile;

    private static final String cDefKodeExternal = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
    @Column(name = "KodeExternal", columnDefinition = cDefKodeExternal)
    private String kodeExternal;

    private static final String cDefNamaExternal = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
    @Column(name = "NamaExternal", columnDefinition = cDefNamaExternal)
    private String namaExternal;

    private static final String cDefReportDisplay = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "ReportDisplay", columnDefinition = cDefReportDisplay)
    @NotNull(message = "jenisprofile.reportdisplay.notnull")
    private String reportDisplay;

    private static final String cDefStatusEnabled =INTEGER;
    @Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
    @NotNull(message = "jenisprofile.statusenabled.notnull")
    @Type(type = "org.hibernate.type.NumericBooleanType") private Boolean statusEnabled;

    private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Column(name = "NoRec", columnDefinition = cDefNoRec)
    @NotNull(message = "jenisprofile.norec.notnull")
    private String noRec;

    private static final String cDefVersion =INTEGER;
    @Version
    @Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
    @NotNull(message = "jenisprofile.version.notnull")
    private Integer version;


	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdJenisProfileHead", referencedColumnName = "KdJenisProfile", insertable = false, updatable = false), })
	//@ForeignKey(name="none")//
	private JenisProfile jenisProfileHead;
}


